/*
 * Copyright 2016 - 2025 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <studio/undocommand.hpp>

#include <nostalgia/gfx/palette.hpp>

namespace nostalgia::gfx {

class ApplyColorAllPagesCommand: public studio::UndoCommand {
	private:
		Palette &m_pal;
		size_t const m_page{};
		size_t const m_idx{};
		ox::Vector<Color16> const m_origColors;

	public:
		ApplyColorAllPagesCommand(Palette &pal, size_t page, size_t idx);

		~ApplyColorAllPagesCommand() noexcept override = default;

		[[nodiscard]]
		int commandId() const noexcept final;

		ox::Error redo() noexcept final;

		ox::Error undo() noexcept final;
};

}